// VTC7250-7C8 API V1.0 2019/01/09
#define VTC7250_7C8_API extern "C" __declspec(dllimport)


struct PortLinkStatus
{
	unsigned char status[8];
};


VTC7250_7C8_API void Get_DLL_Version(int *pnMajorVersion, int *pnMinorVersion);
VTC7250_7C8_API bool Get_BIOS_Version(char *szBIOS_Ver, int nLen);
VTC7250_7C8_API bool Get_BIOS_Version_W(wchar_t *szBIOS_Ver, int nLen);

VTC7250_7C8_API int  Connect();
VTC7250_7C8_API void Disconnect();

VTC7250_7C8_API int  GetMCUVersion(int *pnMCUVersion);
VTC7250_7C8_API int  GetHWVersion(int *pnHWVersion);
VTC7250_7C8_API int  GetDTPVersion(int *pnDTPVersion);
VTC7250_7C8_API int  GetBLVersion(int *pnBLVersion);
VTC7250_7C8_API int  GetIgnitionStatus(int *pnIgnitionStatus);
VTC7250_7C8_API int  GetSupplyVoltage(int *pnSupplyVoltage);
VTC7250_7C8_API int  GetPowerType(int *pnPowerType);
VTC7250_7C8_API int  GetDelayTimeOption(int *pnPowerOff, int *pnPowerOn, int *pnDelayOffEnable, int *pnDelayOnEnable);
VTC7250_7C8_API int  GetStartupShutdownOption(int *pnStartupShutdownOption);
VTC7250_7C8_API int  GetAlarmTimer(int *pnHour, int *pnMin, int *pnSec);
VTC7250_7C8_API int  GetWWANStatus(int *pnWWAN_Enable1, int *pnWWAN_Wakeup_Enable1, int *pnWWAN_Enable2);
VTC7250_7C8_API int  GetWiFiStatus(int *pnWiFi_En1, int *pnWiFi_En2, int *pnWiFi_Pw1, int *pnWiFi_Pw2);
VTC7250_7C8_API int  GetBTStatus(int *pnBTStatus);
VTC7250_7C8_API int  GetGPSStatus(int *pnGPSStatus);
VTC7250_7C8_API int  GetUSBStatus(int *pnUSB3_1, int *pnUSB3_2, int *pnUSB3_3);
VTC7250_7C8_API int  GetRTCStatus(int *pnRTCStatus);
VTC7250_7C8_API int  GetWatchdogConfig(int *pnWDT_Enable, int *pnTimeout);
VTC7250_7C8_API int  GetMDOStatus(int *pnMDO1, int *pnMDO2, int *pnMDO3, int *pnMDO4);
VTC7250_7C8_API int  GetMDIStatus(int *pnMDI1, int *pnMDI2, int *pnMDI3, int *pnMDI4);
VTC7250_7C8_API int  GetGsensorData(int nRegisterIndex, unsigned char *pbyGsensorData, int nGsensorDataLen);
VTC7250_7C8_API int  GetInputFrequency(int *pnInputFrequency);
VTC7250_7C8_API int  GetSIMCardStatus(int nWWAN, int *pnSIM);
VTC7250_7C8_API int  GetProgramLEDStatus(int *pnLED1, int *pnLED2, int *pnLED3, int *pnLED4);
VTC7250_7C8_API int  GetWakeOnLanStatus(int *pnWakeOnLanStatus);
VTC7250_7C8_API int  GetExternal12VStatus(int *pnExternal12VStatus);
VTC7250_7C8_API int  GetPCIE_SATA_Mode(int *pnMode);

VTC7250_7C8_API int  SetLoadDefault();
VTC7250_7C8_API int  SetRTCTimer(int nHour, int nMin, int nSec);
VTC7250_7C8_API int  SetDelayTimeOption(int nPowerOffDelayTime, int nPowerOffDelayTime_Enable, int nPowerOnDelayTime, int nPowerOnDelayTime_Enable);
VTC7250_7C8_API int  SetStartupShutdownOption(int nOption);
VTC7250_7C8_API int  SetAlarmTimer(int nHour, int nMin, int nSec);
VTC7250_7C8_API int  SetWWANControl(int nWWAN_Enable1, int nWWAN_Wakeup_Enable1, int nWWAN_Enable2);
VTC7250_7C8_API int  SetWiFiControl(int nWiFi_En1, int nWiFi_En2, int nWiFi_Pw1, int nWiFi_Pw2);
VTC7250_7C8_API int  SetBTControl(int nBT);
VTC7250_7C8_API int  SetGPSControl(int nEnable);
VTC7250_7C8_API int  SetUSBControl(int nUSB3_1, int nUSB3_2, int nUSB3_3);
VTC7250_7C8_API int  SetRTCControl(int nEnable);
VTC7250_7C8_API int  SetWatchdogControl(int nWDT_Enable);
VTC7250_7C8_API int  SetWatchdogTimer(int nWDT_TimeOut);
VTC7250_7C8_API int  SetFlashUpdate();
VTC7250_7C8_API int  SetMDOControl(int nMDO1, int nMDO2, int nMDO3, int nMDO4);
VTC7250_7C8_API int  SetGsensorData(int nRegIdx, unsigned char *pbyData, int nLen);
VTC7250_7C8_API int  SetSIMCardSelect(int nWWAN, int nSIM);
VTC7250_7C8_API int  SetProgramLEDControl(int nLED1, int nLED2, int nLED3, int nLED4);
VTC7250_7C8_API int  SetWakeOnLanControl(int nEnable);
VTC7250_7C8_API int  SetExternal12VControl(int nEnable);
VTC7250_7C8_API int  SetPCIE_SATA_Mode(int nMode);


// ByPass VTK62B command
// The ExBat APIs are used for VTK62B which connect to 2x4 Double Row 8 Pin Connector socket.
VTC7250_7C8_API int  ExBat_GetMCUVersion(int *pnMCUVersion);
VTC7250_7C8_API int  ExBat_GetHWVersion(int *pnPCB);
VTC7250_7C8_API int  ExBat_GetDTPVersion(int *pnDTPVersion);
VTC7250_7C8_API int  ExBat_GetBLVersion(int *pnBLVersion);
VTC7250_7C8_API int  ExBat_GetIgnitionStatus(int *pnIgnitionStatus);
VTC7250_7C8_API int  ExBat_GetSupplyVoltage(int *pnSupplyVoltage);
VTC7250_7C8_API int  ExBat_GetMDOStatus(int *pnMDO1, int *pnMDO2);
VTC7250_7C8_API int  ExBat_GetPowerType(int *pnPowerType);
VTC7250_7C8_API int  ExBat_GetPowerRange(int *pnPowerRange);

VTC7250_7C8_API int  ExBat_SetFlashUpdate();
VTC7250_7C8_API int  ExBat_SetMDOControl(int nMDO1, int nMDO2);

VTC7250_7C8_API int  ExBat_GetBackupBatteryStatus(int *pnBatteryStatus);
VTC7250_7C8_API int  ExBat_GetSmartBatteryVoltage(int *pnBatteryVoltage);
VTC7250_7C8_API int  ExBat_GetSmartBatteryTemperature(int *pnBatteryTemperature);
VTC7250_7C8_API int  ExBat_GetSmartBatteryStatus(int *pnBatteryStatus);
VTC7250_7C8_API int  ExBat_GetSmartBatteryCapacity(int *pnBatteryCapacity);
VTC7250_7C8_API int  ExBat_GetSmartBatteryCurrent(int *pnBatteryCurrent);
VTC7250_7C8_API int  ExBat_GetThresholdSetting(int *pnThreshold_Low, int *pnThreshold_High);
VTC7250_7C8_API int  ExBat_GetDelayTimeStatus(int *pnStatus);
VTC7250_7C8_API int  ExBat_GetDelayTimeNow(int *pnDelayTime);

VTC7250_7C8_API int  ExBat_SetDelayTimeControl(int nTime);


// PoE command
VTC7250_7C8_API int  GetPSEFWVersion(int *pnPSE1, int *pnPSE2);
VTC7250_7C8_API int  GetPSETemperature(int *pnPSEtemp1, int *pnPSEtemp2);
VTC7250_7C8_API int  GetTotalConsumption(int *pnTotalConsumption);
VTC7250_7C8_API int  GetPOEStatus(unsigned char *pbyStatus);
VTC7250_7C8_API int  GetPortPowerConsumption(int nIndex, int *pnConsumption);
VTC7250_7C8_API int  GetAllPortLinkStatus(PortLinkStatus *pLinkStatus);

// ================================================================================================================================================
typedef void (__stdcall *EventSystemAlarm_CallBack)(unsigned char byAlarm);

VTC7250_7C8_API void RegisterSystemAlarmCallBackFunction(
	EventSystemAlarm_CallBack fnESA);

typedef void (__stdcall *EventSystemSleepKey_CallBack)();

VTC7250_7C8_API void RegisterKeyCallBackFunction(
	EventSystemSleepKey_CallBack fnESSK);

// ================================================================================================================================================
typedef void (__stdcall *ExBat_BackupBatteryAlarm_CallBack)(unsigned char byAlarm);

VTC7250_7C8_API void ExBat_RegisterBatteryCallBackFunction(
	ExBat_BackupBatteryAlarm_CallBack  fnBBA);
